using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Reflection;
using System.Diagnostics;

using Common;

namespace BusyBarDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button _Start;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button _Reset;
		private System.Windows.Forms.PropertyGrid _PainterGrid;
		private System.Windows.Forms.PropertyGrid _BarGrid;
		private System.Windows.Forms.ProgressBar _ProgressBar1;
		private System.Windows.Forms.Button _Stop;
		private Common.BusyBar _BusyBar1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox _PainterPreset;

		private Common.PainterLine painterLine1;
		private Common.PainterClock painterClock1;
		private Common.PainterXP painterXP1;
		private Common.PainterPathGradient painterPathGradient1;
		private Common.PainterSillyscope painterSillyscope1;
		private Common.PainterInstall painterInstall1;
		private Common.PainterFrustratoBar painterFrustratoBar1;

		private BusyBar _BusyBarHorizontal;
		private BusyBar _BusyBarVertical;

		private bool _SelectPainterPresetInternal = false;
		private Work _Work = null;

		public Form1()
		{
			string[] a = Assembly.GetEntryAssembly().GetManifestResourceNames();
			Trace.WriteLine( "\nResourceNames:" );
			foreach ( string s in a ) Trace.WriteLine( "\t" + s );
			Trace.WriteLine( "" );

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// set this property for testing your own custom Painter
			IPainter customPainter = CustomPainter;
			if ( customPainter != null ) _BusyBar1.PainterObject = customPainter;

//			if ( _BusyBar1.PainterWorker is PainterXP )
//				( ( PainterXP ) _BusyBar1.PainterWorker ).Preset = PainterXP.Presets.Startup;

//			if ( _BusyBar1.PainterWorker is PainterInstall )
//				( ( PainterInstall ) _BusyBar1.PainterWorker ).Preset = PainterInstall.Presets.Install;

			_BusyBarHorizontal = ( Common.BusyBar ) _BusyBar1.Clone();
			_BusyBarHorizontal.Location = new Point( _BusyBar1.Location.X, _BusyBar1.Location.Y + _BusyBar1.ClientRectangle.Height + 16 );
			_BusyBarHorizontal.Size = new Size( _BusyBar1.ClientRectangle.Width, 23 );
//			_BusyBarHorizontal.SetRegion();
			Controls.Add( _BusyBarHorizontal );

			_BusyBarVertical = ( Common.BusyBar ) _BusyBar1.Clone();
			_BusyBarVertical.Location = new Point( _BusyBar1.Location.X + _BusyBar1.ClientRectangle.Width + 16, _BusyBar1.Location.Y );
			_BusyBarVertical.Size = new Size( 23, _BusyBar1.ClientRectangle.Height );
//			_BusyBarVertical.SetRegion();
			_BusyBarVertical.Vertical = true;
			Controls.Add( _BusyBarVertical );
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this._ProgressBar1 = new System.Windows.Forms.ProgressBar();
			this._Start = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this._Reset = new System.Windows.Forms.Button();
			this._PainterPreset = new System.Windows.Forms.ComboBox();
			this._PainterGrid = new System.Windows.Forms.PropertyGrid();
			this._BarGrid = new System.Windows.Forms.PropertyGrid();
			this._Stop = new System.Windows.Forms.Button();
			this._BusyBar1 = new Common.BusyBar();
			this.painterFrustratoBar1 = new Common.PainterFrustratoBar();
			this.painterPathGradient1 = new Common.PainterPathGradient();
			this.painterXP1 = new Common.PainterXP();
			this.painterSillyscope1 = new Common.PainterSillyscope();
			this.painterClock1 = new Common.PainterClock();
			this.painterLine1 = new Common.PainterLine();
			this.label1 = new System.Windows.Forms.Label();
			this.painterInstall1 = new Common.PainterInstall();
			((System.ComponentModel.ISupportInitialize)(this._BusyBar1)).BeginInit();
			this.SuspendLayout();
			// 
			// _ProgressBar1
			// 
			this._ProgressBar1.Location = new System.Drawing.Point(16, 256);
			this._ProgressBar1.Name = "_ProgressBar1";
			this._ProgressBar1.Step = 1;
			this._ProgressBar1.TabIndex = 6;
			this._ProgressBar1.Value = 50;
			// 
			// _Start
			// 
			this._Start.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this._Start.Location = new System.Drawing.Point(32, 328);
			this._Start.Name = "_Start";
			this._Start.TabIndex = 7;
			this._Start.Text = "Start";
			this._Start.Click += new System.EventHandler(this._Start_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(176, 16);
			this.label3.Name = "label3";
			this.label3.TabIndex = 1;
			this.label3.Text = "BusyBar";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// _Reset
			// 
			this._Reset.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this._Reset.Location = new System.Drawing.Point(32, 368);
			this._Reset.Name = "_Reset";
			this._Reset.TabIndex = 8;
			this._Reset.Text = "Reset";
			this._Reset.Click += new System.EventHandler(this._Reset_Click);
			// 
			// _PainterPreset
			// 
			this._PainterPreset.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this._PainterPreset.Location = new System.Drawing.Point(464, 16);
			this._PainterPreset.Name = "_PainterPreset";
			this._PainterPreset.Size = new System.Drawing.Size(121, 21);
			this._PainterPreset.TabIndex = 4;
			this._PainterPreset.SelectedIndexChanged += new System.EventHandler(this._PainterPreset_SelectedIndexChanged);
			// 
			// _PainterGrid
			// 
			this._PainterGrid.CommandsVisibleIfAvailable = true;
			this._PainterGrid.LargeButtons = false;
			this._PainterGrid.LineColor = System.Drawing.SystemColors.ScrollBar;
			this._PainterGrid.Location = new System.Drawing.Point(384, 48);
			this._PainterGrid.Name = "_PainterGrid";
			this._PainterGrid.Size = new System.Drawing.Size(200, 384);
			this._PainterGrid.TabIndex = 5;
			this._PainterGrid.Text = "PropertyGrid";
			this._PainterGrid.ViewBackColor = System.Drawing.SystemColors.Window;
			this._PainterGrid.ViewForeColor = System.Drawing.SystemColors.WindowText;
			this._PainterGrid.PropertyValueChanged += new System.Windows.Forms.PropertyValueChangedEventHandler(this._PainterGrid_PropertyValueChanged);
			// 
			// _BarGrid
			// 
			this._BarGrid.CommandsVisibleIfAvailable = true;
			this._BarGrid.LargeButtons = false;
			this._BarGrid.LineColor = System.Drawing.SystemColors.ScrollBar;
			this._BarGrid.Location = new System.Drawing.Point(176, 48);
			this._BarGrid.Name = "_BarGrid";
			this._BarGrid.Size = new System.Drawing.Size(200, 384);
			this._BarGrid.TabIndex = 2;
			this._BarGrid.Text = "PropertyGrid";
			this._BarGrid.ViewBackColor = System.Drawing.SystemColors.Window;
			this._BarGrid.ViewForeColor = System.Drawing.SystemColors.WindowText;
			this._BarGrid.PropertyValueChanged += new System.Windows.Forms.PropertyValueChangedEventHandler(this._BarGrid_PropertyValueChanged);
			// 
			// _Stop
			// 
			this._Stop.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this._Stop.Location = new System.Drawing.Point(32, 408);
			this._Stop.Name = "_Stop";
			this._Stop.TabIndex = 9;
			this._Stop.Text = "Stop";
			this._Stop.Click += new System.EventHandler(this._Stop_Click);
			// 
			// _BusyBar1
			// 
			this._BusyBar1.BackColor = System.Drawing.Color.Black;
			this._BusyBar1.Bounce = true;
			this._BusyBar1.ForeColor = System.Drawing.Color.Red;
			this._BusyBar1.Location = new System.Drawing.Point(16, 16);
			this._BusyBar1.Name = "_BusyBar1";
			this._BusyBar1.PainterObject = this.painterPathGradient1;
			this._BusyBar1.Size = new System.Drawing.Size(100, 100);
			this._BusyBar1.TabIndex = 0;
			this._BusyBar1.Value = 25;
			this._BusyBar1.Wrap = false;
			// 
			// painterFrustratoBar1
			// 
			this.painterFrustratoBar1.BlockLineColor = System.Drawing.Color.White;
			this.painterFrustratoBar1.BlockScroll = false;
			this.painterFrustratoBar1.ColorDark = System.Drawing.Color.FromArgb(((System.Byte)(131)), ((System.Byte)(174)), ((System.Byte)(119)));
			this.painterFrustratoBar1.ColorLight = System.Drawing.Color.FromArgb(((System.Byte)(195)), ((System.Byte)(227)), ((System.Byte)(186)));
			// 
			// painterPathGradient1
			// 
			this.painterPathGradient1.BlockLineColor = System.Drawing.Color.Black;
			this.painterPathGradient1.BlockPercent = 100F;
			this.painterPathGradient1.BlockScroll = false;
			this.painterPathGradient1.BlockSmooth = true;
			this.painterPathGradient1.ColorCentre = System.Drawing.Color.Red;
			this.painterPathGradient1.ColorCorner = System.Drawing.Color.Black;
			this.painterPathGradient1.ColorHorizontal = System.Drawing.Color.Black;
			this.painterPathGradient1.ColorVertical = System.Drawing.Color.Black;
			this.painterPathGradient1.Shape = Common.PainterPathGradient.Shapes.Diamond;
			// 
			// painterXP1
			// 
			this.painterXP1.BlockLineColor = System.Drawing.Color.White;
			this.painterXP1.ColorDark = System.Drawing.Color.FromArgb(((System.Byte)(131)), ((System.Byte)(174)), ((System.Byte)(119)));
			this.painterXP1.ColorLight = System.Drawing.Color.FromArgb(((System.Byte)(195)), ((System.Byte)(227)), ((System.Byte)(186)));
			// 
			// painterSillyscope1
			// 
			this.painterSillyscope1.GridLineColor = System.Drawing.Color.Silver;
			this.painterSillyscope1.LineColor = System.Drawing.Color.Red;
			this.painterSillyscope1.Points = new System.Drawing.PointF[] {
																			 ((System.Drawing.PointF)(resources.GetObject("resource"))),
																			 ((System.Drawing.PointF)(resources.GetObject("resource1"))),
																			 ((System.Drawing.PointF)(resources.GetObject("resource2"))),
																			 ((System.Drawing.PointF)(resources.GetObject("resource3")))};
			// 
			// painterClock1
			// 
			this.painterClock1.HourColor = System.Drawing.Color.Red;
			this.painterClock1.MarksColor = System.Drawing.Color.Red;
			this.painterClock1.MinuteColor = System.Drawing.Color.Red;
			// 
			// painterLine1
			// 
			this.painterLine1.LineColor = System.Drawing.Color.Red;
			this.painterLine1.LineWidth = 25;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(384, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 23);
			this.label1.TabIndex = 3;
			this.label1.Text = "Painter";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// painterInstall1
			// 
			this.painterInstall1.BackColor = System.Drawing.Color.Green;
			this.painterInstall1.BackOutlineColor = System.Drawing.Color.Silver;
			this.painterInstall1.BlockCount = 5;
			this.painterInstall1.ForeColor = System.Drawing.Color.Lime;
			this.painterInstall1.ForeOutlineColor = System.Drawing.Color.White;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(594, 448);
			this.Controls.Add(this.label1);
			this.Controls.Add(this._BusyBar1);
			this.Controls.Add(this._BarGrid);
			this.Controls.Add(this._PainterGrid);
			this.Controls.Add(this._PainterPreset);
			this.Controls.Add(this.label3);
			this.Controls.Add(this._Start);
			this.Controls.Add(this._ProgressBar1);
			this.Controls.Add(this._Reset);
			this.Controls.Add(this._Stop);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "BusyBarDemo";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this._BusyBar1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles();
			Application.DoEvents();

			Application.Run(new Form1());
		}

//-----------------------------------------------------------------------------
// Work

		private class Work
		{
			private int _Interval = 10;
			private Thread _Thread = null;
			private volatile bool _Stop = false;

			public int Interval { get { return _Interval; } set { _Interval = value; } }
			public Thread Thread { get { return _Thread; } }

			public event EventHandler Step;

			public Work()
			{
			}

			public void Start()
			{
				_Thread = new Thread( new ThreadStart( DoWork ) );
				_Thread.Priority = ThreadPriority.Lowest;
				_Thread.IsBackground = true;
				_Thread.Name = "Worker";
				_Thread.Start();
			}

			public void Stop()
			{
				_Stop = true;
			}

			private void DoWork()
			{
				for(;;)
				{
					if ( Step != null ) Step( this, EventArgs.Empty );

					DateTime start = DateTime.Now;

					for(;;)
					{
//						Thread.SpinWait( 1000000 );
						Thread.Sleep( 1 );

						TimeSpan interval = DateTime.Now - start;

						if ( interval.TotalMilliseconds >= _Interval ) break;
					}

					if ( _Stop ) break;
				}
			}
		}

		private void _Start_Click( object sender, System.EventArgs e )
		{
			_BarGrid.Refresh();
			_PainterGrid.Refresh();

			if ( _Work == null )
			{
				_Work = new Work();
				_Work.Step += new EventHandler( _Work_Step );
				_Work.Start();
			}
		}

		private void _Stop_Click( object sender, System.EventArgs e )
		{
			if ( _Work != null )
			{
				_Work.Stop();
				_Work = null;
			}

			_BarGrid.Refresh();
			_PainterGrid.Refresh();
		}

		private void Form1_Closing( object sender, System.ComponentModel.CancelEventArgs e )
		{
			if ( _Work != null )
			{
				_Work.Stop();
				_Work.Thread.Join();
			}
		}

		private void _Work_Step( object sender, EventArgs args )
		{
			BeginInvoke( _BusyBarPerformStepDelegate, new object[] { new BusyBarPerformStepArgs( _BusyBar1          ) } );
			BeginInvoke( _BusyBarPerformStepDelegate, new object[] { new BusyBarPerformStepArgs( _BusyBarHorizontal ) } );
			BeginInvoke( _BusyBarPerformStepDelegate, new object[] { new BusyBarPerformStepArgs( _BusyBarVertical   ) } );

			BeginInvoke( _ProgressBarPerformStepDelegate, new object[] { new ProgressBarPerformStepArgs( _ProgressBar1   ) } );
		}

		private class BusyBarPerformStepArgs
		{
			public BusyBar BusyBar;
			public BusyBarPerformStepArgs( BusyBar busyBar ) { BusyBar = busyBar; }
		}

		private delegate void BusyBarPerformStepDelegate( BusyBarPerformStepArgs args );

		private BusyBarPerformStepDelegate _BusyBarPerformStepDelegate = new BusyBarPerformStepDelegate( BusyBarPerformStep );

		private static void BusyBarPerformStep( BusyBarPerformStepArgs args )
		{
			args.BusyBar.PerformStep();
		}


		private class ProgressBarPerformStepArgs
		{
			public ProgressBar ProgressBar;
			public ProgressBarPerformStepArgs( ProgressBar progressBar ) { ProgressBar = progressBar; }
		}

		private delegate void ProgressBarPerformStepDelegate( ProgressBarPerformStepArgs args );

		private ProgressBarPerformStepDelegate _ProgressBarPerformStepDelegate = new ProgressBarPerformStepDelegate( ProgressBarPerformStep );

		private static void ProgressBarPerformStep( ProgressBarPerformStepArgs args )
		{
			args.ProgressBar.PerformStep();
			if ( args.ProgressBar.Value >= 100 ) args.ProgressBar.Value = 0;
		}

//-----------------------------------------------------------------------------
// Form1_Load

		private void Form1_Load( object sender, System.EventArgs e )
		{
			_BarGrid.SelectedObject = _BusyBar1;

			Array a = Enum.GetValues( typeof( BusyBar.PainterPresets ) );
			ArrayList l = new ArrayList( a.Length );
			foreach ( int i in a )
				l.Add( new PainterData( Enum.GetName( typeof( BusyBar.PainterPresets ), i ), ( BusyBar.PainterPresets ) i ) );

			_PainterPreset.BeginUpdate();
			_PainterPreset.DataSource = l;
			_PainterPreset.DisplayMember = "Name";
			_PainterPreset.ValueMember = "Value";
			_PainterPreset.EndUpdate();



			if ( _BusyBar1.PainterObject != null )
				_PainterGrid.SelectedObject = _BusyBar1.PainterWorker;
			else
			{
				_SelectPainterPresetInternal = true;
				_PainterPreset.SelectedValue = _BusyBar1.PainterPreset;
				_SelectPainterPresetInternal = false;
			}
		}

		private class PainterData
		{
			private string _Name = String.Empty;
			private BusyBar.PainterPresets _Value = BusyBar.PainterPresets.None;

			public string Name { get { return _Name; } }
			public BusyBar.PainterPresets Value { get { return _Value; } }

			public PainterData( string name, BusyBar.PainterPresets value )
			{
				_Name = name;
				_Value = value;
			}
		}

//-----------------------------------------------------------------------------
// Event handlers

		private void _Reset_Click(object sender, System.EventArgs e)
		{
			_BusyBar1.Reset();
			_BusyBarHorizontal.Reset();
			_BusyBarVertical.Reset();

			_ProgressBar1.Value = 0;

			_BarGrid.Refresh();
			_PainterGrid.Refresh();
		}

		private void _BarGrid_PropertyValueChanged(object s, System.Windows.Forms.PropertyValueChangedEventArgs e)
		{
			GridItem item = e.ChangedItem;

			PropertyDescriptor pd = item.PropertyDescriptor;
			object value = item.Value;

			pd.SetValue( _BusyBar1, value );
			pd.SetValue( _BusyBarHorizontal, value );
			pd.SetValue( _BusyBarVertical, value );

			if ( pd.Name == "PainterPreset" )
			{
				_PainterPreset.SelectedValue = _BusyBar1.PainterPreset;
			}

			_BarGrid.Refresh();
			_PainterGrid.Refresh();
		}

		private void _PainterPreset_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			object o = _PainterPreset.SelectedValue;

			if ( o is BusyBar.PainterPresets && ! _SelectPainterPresetInternal )
			{
				BusyBar.PainterPresets painter = ( BusyBar.PainterPresets ) o;

				_BusyBar1.PainterPreset = painter;
				_BusyBarHorizontal.PainterPreset = painter;
				_BusyBarVertical.PainterPreset = painter;
			}

			_BarGrid.Refresh();
			_PainterGrid.SelectedObject = _BusyBar1.PainterWorker;
		}

		private void _PainterGrid_PropertyValueChanged(object s, System.Windows.Forms.PropertyValueChangedEventArgs e)
		{
			GridItem item = e.ChangedItem;

			PropertyDescriptor pd = item.PropertyDescriptor;
			object value = item.Value;

			pd.SetValue( _BusyBar1.PainterWorker, value );
			pd.SetValue( _BusyBarHorizontal.PainterWorker, value );
			pd.SetValue( _BusyBarVertical.PainterWorker, value );

			_BarGrid.Refresh();
			_PainterGrid.Refresh();
		}

//-----------------------------------------------------------------------------
// Painter

		// Return an instance of your own custom Painter
		private IPainter CustomPainter
		{
			get
			{
				return null;
//				return new PainterLine( _BusyBar1, false );
//				return new PainterPathGradient( _BusyBar1, false );
			}
		}

//-----------------------------------------------------------------------------

	} // Form1

//-----------------------------------------------------------------------------

}
